package cn.ibizlab.assetmanagement.core.location.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.location.domain.EAMLocationStateModel;
import cn.ibizlab.assetmanagement.core.location.filter.EAMLocationStateModelSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMLocationStateModel] 服务对象接口
 */
public interface IEAMLocationStateModelService extends IService<EAMLocationStateModel>{

    boolean create(EAMLocationStateModel et) ;
    void createBatch(List<EAMLocationStateModel> list) ;
    boolean update(EAMLocationStateModel et) ;
    void updateBatch(List<EAMLocationStateModel> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMLocationStateModel get(String key) ;
    EAMLocationStateModel getDraft(EAMLocationStateModel et) ;
    boolean checkKey(EAMLocationStateModel et) ;
    boolean save(EAMLocationStateModel et) ;
    void saveBatch(List<EAMLocationStateModel> list) ;
    Page<EAMLocationStateModel> searchDefault(EAMLocationStateModelSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMLocationStateModel> getEamlocationstatemodelByIds(List<String> ids) ;
    List<EAMLocationStateModel> getEamlocationstatemodelByEntities(List<EAMLocationStateModel> entities) ;
}


